function Create(self)
    self.guncurdist = 40; --The distance of the bullet from the gun.
    for i = 1,MovableMan:GetMOIDCount()-1 do
        self.gun = MovableMan:GetMOFromID(i);
        if self.gun.PresetName == "Masher" and self.gun.ClassName == "HDFirearm" and (self.gun.Pos-self.Pos).Magnitude < self.guncurdist then --Change presetname as apppropriate.
            self.actor = MovableMan:GetMOFromID(self.gun.RootID);
            if MovableMan:IsActor(self.actor) then
                self.parent = ToActor(self.actor);
            end
         end
    end
end

function Update(self)
	local foundbomf = false;
	self.ToDelete = true;
	for actor in MovableMan.Actors do
		if math.abs(actor.Pos.X - self.Pos.X) < 70 and math.abs(actor.Pos.Y - self.Pos.Y) < 70 and actor.ID ~= self.parent.ID then
			actor.Vel = actor.Vel + self.Vel;
			actor.PinStrength = 0;
			for i=0, 10, 1 do
				local particle = CreateMOPixel("Masher Spark", "Masher.rte");
				particle.Pos = self.Pos;
				particle.Vel = (self.Vel / 4)  + Vector(RangeRand(-10, 10), RangeRand(-10, 10));
				MovableMan:AddParticle(particle);
			end
			for i=0, 150, 1 do
				local particle = CreateMOSRotating("Masher Steam", "Masher.rte");
				particle.Pos = self.Pos;
				particle.Vel = (self.Vel / 2) + Vector(RangeRand(-20, 20), RangeRand(-20, 20));
				MovableMan:AddParticle(particle);
			end
			foundbomf = true;
		end
	end --For loop
	if not foundbomf then
		local particle = CreateMOPixel("Teleport Laser", "Masher.rte")
		particle.Pos = self.Pos;
		particle.Vel = self.Vel;
		MovableMan:AddParticle(particle)
		for i=0, 10, 1 do
			particle = CreateMOPixel("Masher Spark", "Masher.rte");
			particle.Pos = self.Pos;
			particle.Vel = (self.Vel / 4)  + Vector(RangeRand(-10, 10), RangeRand(-10, 10));
			MovableMan:AddParticle(particle);
		end
	end
end